# The Mill's Fabula - v0.3.0

This little [FoundryVTT](https://foundryvtt.com/) module is a collection of compendiums and functionalities
to power our Fabula Ultima campaigns.

# Compatibility

This is *only* compatible with Foundry v12 currently.

# Installation

Currently, this can only be installed via manifest file, using the following URL :
```
https://git.tfk-astrodome.net/trotFunky/TheMillsFabula/raw/branch/release/module.json
```

# Features

This module is an aggregate of different things that are useful for us or that the GM wanted
to play with, so they don't necessarily connect with each other and can be disabled if wanted.

They are described below in their own sections.

## Combat border

This part of the module adds a dynamic border around player tokens, which changes during combat.

The border is always visible, but after a player has taken their turn it will switch to a different border,
highlighting the tokens that have played for this combat turn.

The module supports going back and forth in the combat rounds, as well as going back in the turn order.
(Though because of limitations of the Fabula Ultima system, does not allow going *forward* in the turn order.)

### Settings

- An image to use for the default/idle border
- An image to use for the took turn/played/inactive border

### Limitations

There are currently one minor issue that might be fixed :
1. The token borders will be incorrect when switching between different encounters in the same scene
   - Producing a combat event or switching away and back to the scene will fix it.
   - It doesn't appear that there is an event on combat switch that could be hooked into, which makes fixing the
     issue uncertain.

## Token UI adjustments

Given that we add a border *on* the tokens, it conflicts with the base attribute bars which are drawn over the token's
square.  
The token UI adjustments move the two attribute bars below the token, outside its space, first HP then mana.  
As this is where the nameplate of the token should be, move it above the token instead.

### Limitations

- The token's detailed UI when right-clicking will overlap the bars in their new positions (it already overlapped the name)
- The current implementation relies on monkey patching, which make it vulnerable to compatibility issues with
  other modules manipulating the same methods.

# Compendia

- The only thing in the compendium pack is a macro automating the tinkerer's alchemy potions,
  allowing to choose how many PIs to spend, how to allocate the results, previews and a final chat message
  with the results.

# Dependencies

Modules:
 - socketlib

System:
 - Fabula Ultima

# License

The code present in this repository is licensed under the Mozilla Public License 2.0.

Assets that we created in this repository are licensed under
[CC-BY-SA 4.0](https://creativecommons.org/licenses/by-sa/4.0/), unless otherwise specified.
